<template>
  <b-modal
    ref="theModal"
    :title="modalTitle"
    size="xl"
    no-close-on-esc
    no-close-on-backdrop
    hide-header-close
  >
    <b-form @submit.prevent="onSave">
      <b-form-group label="Date displayed (UTC)">
        <FormFieldDatepicker
          v-model="form.dateDisplay"
          :disabled="!canEdit"
        ></FormFieldDatepicker>
      </b-form-group>

      <b-form-group label="Title internal">
        <b-form-input
          v-model="form.titleInternal"
          :disabled="!canEdit"
        ></b-form-input>
      </b-form-group>

      <div>
        <div
          v-b-toggle.translations
          class="text-link-color cursor-pointer mb-3"
        >
          toggle translations
        </div>
        <b-collapse id="translations" :visible="canOnlyTranslate" class="pl-4">
          <b-form-group
            :label="'Title: ' + lang"
            v-for="lang in languages"
            :key="lang"
          >
            <b-form-input v-model="form.title[lang]"></b-form-input>
          </b-form-group>
        </b-collapse>
      </div>

      <b-form-group label="Link to">
        <b-form-input v-model="form.linkTo" :disabled="!canEdit"></b-form-input>
      </b-form-group>

      <b-form-group label="Image">
        <SimpleFileSelector
          v-model="form.imageId"
          :disabled="!canEdit"
        ></SimpleFileSelector>
      </b-form-group>
    </b-form>

    <b-alert :show="warnings.length > 0" variant="danger" class="mt-2">
      <div v-for="warning in warnings">
        <font-awesome-icon
          :icon="['fas', 'exclamation-triangle']"
          class="mr-2"
        ></font-awesome-icon>
        {{ warning }}
      </div>
    </b-alert>

    <template v-slot:modal-footer>
      <b-button @click="onCancel" variant="danger">CANCEL</b-button>
      <b-button
        @click="onSave"
        :disabled="!isValidForm"
        variant="success"
        class="ml-2"
        >SAVE</b-button
      >
    </template>
  </b-modal>
</template>

<script>
import FormFieldDatepicker from '~/components/form/FormFieldDatepicker';
import SimpleFileSelector from '~/components/form/SimpleFileSelector';
import AuthorizedMixin from '~/components/security/AuthorizedMixin';
export default {
  components: { SimpleFileSelector, FormFieldDatepicker },
  mixins: [AuthorizedMixin],
  props: {
    languages: {
      type: Array,
      default: () => {
        return [];
      },
    },
    fallbackLanguage: {
      type: String,
      default: 'en',
    },
  },
  data() {
    return {
      entry: null,
      form: {
        title: {},
      },
      formDefault: {
        title: {},
      },
    };
  },
  computed: {
    warnings() {
      const warn = [];

      if (!this.form.linkTo || this.form.linkTo === '') {
        warn.push('No link set.');
      }

      if (!this.form.imageId || this.form.imageId === '') {
        warn.push('No image set.');
      }

      if (!this.form.dateDisplay || this.form.dateDisplay === '') {
        warn.push('No date set.');
      }

      if (
        !this.form.title[this.fallbackLanguage] ||
        this.form.title[this.fallbackLanguage] === ''
      ) {
        warn.push(
          'No translation for fallback-language ' +
            this.fallbackLanguage.toUpperCase() +
            ' set.'
        );
      }

      if (!this.form.titleInternal || this.form.titleInternal === '') {
        warn.push('No internal title set.');
      }

      return warn;
    },
    canEdit() {
      return this.isAuthorized(['NEWS_EDIT']);
    },
    canOnlyTranslate() {
      return (
        !this.isAuthorized(['NEWS_EDIT']) &&
        this.isAuthorized(['NEWS_TRANSLATE'])
      );
    },
    editMode() {
      return this.entry !== null;
    },
    modalTitle() {
      if (this.editMode) {
        return 'Edit: ' + this.entry.titleInternal;
      }
      return 'New News-Entry';
    },
    isValidForm() {
      if (this.entry && this.entry.published) {
        return this.form.title.en && this.form.title.en !== '';
      }

      return (
        this.form && this.form.titleInternal && this.form.titleInternal !== ''
      );
    },
  },
  mounted() {
    this.resetForm();
  },
  methods: {
    resetForm() {
      this.form = JSON.parse(JSON.stringify(this.formDefault));
    },
    show(entry) {
      this.resetForm();

      if (entry) {
        this.entry = entry;

        this.form = JSON.parse(JSON.stringify(entry));
      } else {
        this.entry = null;
      }

      this.$refs.theModal.show();
    },
    hide() {
      this.$refs.theModal.hide();
    },
    toggle() {
      this.$refs.theModal.toggle();
    },
    onCancel() {
      this.hide();
    },
    onSave() {
      this.$emit('save', this.entry, this.form);
    },
  },
};
</script>
